//Made By TrustFm.net (for www.hw2sw.com)

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
#include "Menu.h"

Menu::Menu()
{

}

MenuCell* Menu::GetMenuCell(byte index)
{
  return &ArrayMenuCell[index];
}

MenuCell* Menu::GetNextDownMenuCell(MenuCell* current)
{ 
  (*current).SetIsSelected(false);
  (*((*current).GetNextDown())).SetIsSelected(true);
  return (*current).GetNextDown();
}

MenuCell* Menu::GetNextRightMenuCell(MenuCell* current)
{  
  (*current).SetIsSelected(false);
  (*((*current).GetNextRight())).SetIsSelected(true);
  return (*current).GetNextRight();
}

MenuCell* Menu::GetFatherMenuCell(MenuCell* current)
{  
  (*current).SetIsSelected(false);
  (*((*current).GetFather())).SetIsSelected(true);
  return (*current).GetFather();
}

MenuCell* Menu::GetSelectedMenuCell()
{
  
  int i;
  for (i = 0; i < MENUSIZE; i = i + 1) {
    if (ArrayMenuCell[i].GetIsSelected()==true) {
      return &ArrayMenuCell[i];
    }
  }
  
  return &ArrayMenuCell[0]; //We assume that at position 0 is the root

}

byte Menu::GetSize()
{
  return MENUSIZE;
}


