//Made By TrustFm.net (for www.hw2sw.com)

#ifndef Menu_h
#define Menu_h

#define MENUSIZE 26 //26 ELEMENTS

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
#include "MenuCell.h"

class Menu
{

  private:
    MenuCell ArrayMenuCell[MENUSIZE]; // An array of MenuCell objects using default constructor
                                      // 0 ... MENUSIZE-1
    
  public:
    Menu();
    MenuCell* GetMenuCell(byte index);
    MenuCell* GetNextDownMenuCell(MenuCell* current);
    MenuCell* GetNextRightMenuCell(MenuCell* current);
    MenuCell* GetFatherMenuCell(MenuCell* current);
    MenuCell* GetSelectedMenuCell();
    byte GetSize();
	
};

#endif

